#!/usr/bin/perl

# Controllare i parametri inseriti in input - Sono di più ? Sono corretti ?
die "Too much arguments in input" if ($#ARGV > 0);
$accessLog = shift || die "No argument in ARGV[0]";

# Apri il file di log in modalità sola lettura (ricordarsi di gestire eventuali errori e di chiudere il file)
open($access, "<", $accessLog) || die "Cannot open file $accessLog";

# Creare il tuo hash che conterrà come chiave la stringa che identifica il nome file e come
# valore un filehandle
%hashFile;

# Scorri il file di log
while(my $line=<$access>)
{
  chomp $line;
  # Espressione regolare... effettua il matching dell'intera espressione e salva nelle variabili $1, $2 e $3 i blocchi che ci servono
  if ($line =~ m/(.*)\s(?:[\w*\-]\s){2}\[.*\]\s"(.*)"\s(\d{3})\s.*/)
  {
    # Splitta la risorsa per ottenere solo ciò che realmente serve
    @resources = split(' ', $2);

    # Se è una nuova chiave (nuovo file da aprire) apri il file e salva il filehandle nell'hash
    if (! exists $hashFile{$3})
    {
      $filename = "stato_".$3;

      # ATTENZIONE: Stiamo creando una variabile stringa che conterrà il nome della variabile filehandle
      $filehandleName = "statoFile_".$3;

      # Il doppio $$ davanti una variabile di questo tipo crea una variabile dal nome uguale al contenuto
      # della variabile filehandleName
      # Esempio: $filehandle = "ciao";
      #          $$filehandle è una variabile di nome ciao (come se scrivessi $ciao;)
      #          quindi sarà possibile fare qualcosa di questo tipo: $$filehandle = "HELLO WORLD !";
      #          print $ciao; ---> HELLO WORLD !

      open($$filehandleName, ">", $filename) || die "Cannot open file $filename";
      $hashFile{$3} = $$filehandleName;
    }
    $currentFile = $hashFile{$3};
    print $currentFile "$1 : $resources[1]\n";
  }
}

# Non dimentichiamo di chiudere tutti i file che abbiamo aperto
close($access) || die "Cannot close file $accessLog";

foreach $key (keys %hashFile)
{
  print "Sto provando a chiudere il file $key\n";
  close($hashFile{$key}) || die "Cannot close file $key";
  print "Ho chiuso il file $key\n\n";

}
